package cn.com.ty.lift.system.homepage.service;

import cn.com.ty.lift.common.constants.ApiConstants;
import cn.com.ty.lift.system.constants.CommonConstants;
import cn.com.ty.lift.system.homepage.dao.dto.request.PlatformCalendarRequest;
import cn.com.ty.lift.system.homepage.dao.mapper.CommonDataMapper;
import cn.com.ty.lift.system.homepage.dao.model.AnnualInspectionDataModel;
import cn.com.ty.lift.system.homepage.dao.model.EmergencyRecordDataModel;
import cn.com.ty.lift.system.homepage.dao.model.MtPlanDataModel;
import cn.com.ty.lift.system.homepage.dao.model.MtRecordDataModel;
import cn.com.ty.lift.system.utils.CommonUtil;
import cn.com.xwy.boot.web.dto.RestResponse;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * @author huangyuan
 * @date 2020/2/14
 * @description 平台日历
 */
@Service
public class PlatformCalendarService {

    @Resource
    private CommonDataMapper commonDataMapper;

    /**
     * @param
     * @return
     * @description 任务数
     * @date 2020/2/14 6:59 下午
     */
    public RestResponse taskNum(PlatformCalendarRequest platformCalendarRequest) {
        Map<Integer, Map<Integer, Long>> dayToLiftDataToNum = CommonUtil.initCalendarMapData(
                platformCalendarRequest.getRequestDateStr(), CommonConstants.PlatformCalendarConstants.REQUEST_DATE_FORMAT);
        //时间转化
        CommonUtil.setMonthDate(platformCalendarRequest);
        //获取当前公司的维保记录 传递时间值 月初时间 - 当前时间
        List<MtRecordDataModel> mtRecordDataModelList = commonDataMapper
                .getMonthBeginToNowMtRecord(platformCalendarRequest);
        //获取当前公司的维保计划 传递时间值 当前时间 - 月末时间
        List<MtPlanDataModel> mtPlanDataModelList = commonDataMapper
                .getMonthNowToEndMtPlan(platformCalendarRequest);
        //获取当前公司的急修记录 传递时间值 月初时间 - 当前时间
        List<EmergencyRecordDataModel> emergencyRecordDataModelList = commonDataMapper
                .getMonthBeginToNowEmergencyRecord(platformCalendarRequest);
        //获取当前公司的年检记录 传递时间值 月初时间 - 月末时间
        List<AnnualInspectionDataModel> annualInspectionDataModelList = commonDataMapper
                .getMonthBeginToEndAnnualInspectionRecord(platformCalendarRequest);

        return RestResponse.success(dayToLiftDataToNum, ApiConstants.RESULT_SUCCESS, "获取任务数成功");
    }

    /**
     * @param
     * @return
     * @description 任务电梯列表
     * @date 2020/2/14 7:01 下午
     */
    public RestResponse taskLiftNum() {
        return RestResponse.success(ApiConstants.RESULT_SUCCESS, "获取任务数成功");
    }
}
